#include "hapio.h" 
#include "emsubs.h" 

int smaxlist = 16384 ;
int smaxn = 15 ;
double spriorfac=0.0 ;
double spriorg= 0.1 ;
int sdebug = NO ;

void
setcm(int *udata, int nt, int len, int *cmax, int *cmin)  ;

void
setpdata(int *pdata, int *bdata, int nt, int len, int *cmax, int *cmin)  ;

void
setbdata(int *bdata, int *udata, int nt, int len, int *cmax, int *cmin)  ;


void emdoit(int *odata, int *udata, int nt, int len, int *base1, int *base2) 
{
 int *bdata, *xdata ;

 ZALLOC(bdata, nt*len, int) ;
 ZALLOC(xdata, nt*len, int) ;
 setbdata(bdata, udata, nt, len, base1, base2) ;
 emphase(xdata, bdata,  nt, len) ; 
 setpdata(xdata, xdata, nt, len, base1, base2) ;
 copyiarr(xdata, odata, nt*len) ;

 free(bdata) ;
 free(xdata) ;

}


void
setcm(int *udata, int nt, int len, int *cmax, int *cmin)  
{
  int cnts[5] ;
  int i,k,x, kmax ;

  for (k=0; k<len; k++) { 
   ivclear(cnts,0,5) ;
   for (i=0; i<nt; i++)  {
     x = udata[i*len+k] ;
     if (x<=0) continue ;
     if (x>4)  continue ;
     ++cnts[x] ;
   }
   cnts[0] = -99 ;
   ivlmaxmin(cnts,5,&kmax, NULL) ;
   if (cnts[kmax] == 0) { /* no data */ 
    cmax[k] = 1 ;
    cmin[k] = 2 ;
    continue ;
   }
   cmax[k] = kmax ;
   cnts[kmax] = -99 ;
   ivlmaxmin(cnts,5,&kmax, NULL) ;
   if (cnts[kmax] == 0) { /* no minor */ 
    cmin[k] = 2 ;
    if (cmax[k] == 2) cmin[k] = 1 ;
    continue ;
   }
   cmin[k] = kmax ;
  }
}
void
setpdata(int *pdata, int *bdata, int nt, int len,
 int *cmax, int *cmin)  
{
   int i,j,k,x;
   for (i=0; i<nt; i++)  {
    for (j=0; j<len; j++)  {
     k = i*len+j ;
     x = bdata[k] ;
     if (x==0) {  
      pdata[k] = cmax[j] ;
      continue ;
     }
     if (x==1) {  
      pdata[k] = cmin[j] ;
      continue ;
     }
     fprintf(stderr,"bad bdata %d %d %d\n",i,j,k) ;
     fatalx("bad bdata %d %d %d\n",cmax[j], cmin[j], x) ;
    }
   }
}
void
setbdata(int *bdata,int *udata, int nt, int len, int *cmax, int *cmin)  
{
   int i,j,k,x;
   for (i=0; i<nt; i++)  {
    for (j=0; j<len; j++)  {
     k = i*len+j ;
     x = udata[k] ;
     if (x==0) {  
      bdata[k] = -1 ;
      continue ;
     }
     if (x==9) {  
      bdata[k] = 9 ;
      continue ;
     }
     if (cmax[j] == x) { 
      bdata[k] = 0  ;
      continue ;
     }
     if (cmin[j] == x) { 
      bdata[k] = 1  ;
      continue ;
     }
     fprintf(stderr,"bad data %d %d %d\n",i,j,k) ;
     fatalx("bad data %d %d %d\n",cmax[j], cmin[j], x) ;
    }
   }
}
